package mod.mcreator;

import net.minecraftforge.fml.relauncher.SideOnly;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.common.registry.GameRegistry;
import net.minecraftforge.fml.common.registry.EntityEntry;
import net.minecraftforge.fml.common.network.NetworkRegistry;
import net.minecraftforge.fml.common.network.IGuiHandler;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.common.event.FMLServerStartingEvent;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.common.SidedProxy;
import net.minecraftforge.fml.common.Mod.Instance;
import net.minecraftforge.fml.common.Mod.EventHandler;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.common.IWorldGenerator;
import net.minecraftforge.fml.common.IFuelHandler;
import net.minecraftforge.fluids.FluidRegistry;
import net.minecraftforge.event.RegistryEvent;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.client.event.ModelRegistryEvent;

import net.minecraft.world.gen.IChunkGenerator;
import net.minecraft.world.chunk.IChunkProvider;
import net.minecraft.world.biome.Biome;
import net.minecraft.world.World;
import net.minecraft.item.ItemStack;
import net.minecraft.item.Item;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.block.Block;

import java.util.function.Supplier;
import java.util.Random;
import java.util.List;
import java.util.ArrayList;

@Mod(modid = advanced_redstone.MODID, version = advanced_redstone.VERSION)
public class advanced_redstone implements IFuelHandler, IWorldGenerator {

	public static final String MODID = "advanced_redstone";
	public static final String VERSION = "1.0.7";
	@SidedProxy(clientSide = "mod.mcreator.ClientProxyadvanced_redstone", serverSide = "mod.mcreator.CommonProxyadvanced_redstone")
	public static CommonProxyadvanced_redstone proxy;
	@Instance(MODID)
	public static advanced_redstone instance;
	public final List<ModElement> elements = new ArrayList<>();
	public final List<Supplier<Block>> blocks = new ArrayList<>();
	public final List<Supplier<Item>> items = new ArrayList<>();
	public final List<Supplier<Biome>> biomes = new ArrayList<>();
	public final List<Supplier<EntityEntry>> entities = new ArrayList<>();

	public advanced_redstone() {
		FluidRegistry.enableUniversalBucket();
		elements.add(new mcreator_startEmitProc(this));
		elements.add(new mcreator_recieveEmit(this));
		elements.add(new mcreator_stopEmitProc(this));
		elements.add(new mcreator_emitter(this));
		elements.add(new mcreator_receiver(this));
		elements.add(new mcreator_emitterPlaced(this));
		elements.add(new mcreator_setEmitterIDCommandExecuted(this));
		elements.add(new mcreator_setEmitterID(this));
		elements.add(new mcreator_receiverBlockAdded(this));
		elements.add(new mcreator_extenderRedstoneOn(this));
		elements.add(new mcreator_extenderUpdateTick(this));
		elements.add(new mcreator_extender(this));
		elements.add(new mcreator_redstoneTable(this));
		elements.add(new mcreator_repeaterL(this));
		elements.add(new mcreator_delayAdjustGUIOnButtonClicked(this));
		elements.add(new mcreator_delayAdjustGUI(this));
		elements.add(new mcreator_extenderOnBlockRightClicked(this));
		elements.add(new mcreator_wirelessPairingTool(this));
		elements.add(new mcreator_extenderRedstoneOff(this));
		elements.add(new mcreator_emitterOnBlockRightClicked(this));
		elements.add(new mcreator_receiverOnBlockRightClicked(this));
		elements.add(new mcreator_wirelessPairTick(this));
		elements.add(new mcreator_filter(this));
		elements.add(new mcreator_filterGUI(this));
		elements.add(new mcreator_filterOnBlockRightClicked(this));
		elements.add(new mcreator_filterTick(this));
		elements.add(new mcreator_filterRecipe(this));
		elements.add(new mcreator_emitterRecipe(this));
		elements.add(new mcreator_beginner(this));
		elements.add(new mcreator_firstFilter(this));
		elements.add(new mcreator_repeaterIndev(this));
		elements.add(new mcreator_repeaterLBlockIsPlacedBy(this));
		elements.add(new mcreator_filterBlockIsPlacedBy(this));
		elements.add(new mcreator_pairingToolRecipe(this));
		elements.add(new mcreator_receiverRecipe(this));
		elements.add(new mcreator_coil(this));
		elements.add(new mcreator_coilRecipe(this));
		elements.add(new mcreator_trigger(this));
		elements.add(new mcreator_triggerUpdate(this));
		elements.add(new mcreator_triggerActiveRedstoneOff(this));
		elements.add(new mcreator_triggerActive(this));
		elements.add(new mcreator_triggerEntityCollidesInTheBlock(this));
		elements.add(new mcreator_triggerActiveBlockAdded(this));
		elements.add(new mcreator_triggerActiveNeighbourBlockChanges(this));
		elements.add(new mcreator_triggerActiveEntityCollidesInTheBlock(this));
		elements.add(new mcreator_triggerActiveUpdateTick(this));
	}

	@Override
	public int getBurnTime(ItemStack fuel) {
		for (ModElement element : elements) {
			int ret = element.addFuel(fuel);
			if (ret != 0)
				return ret;
		}
		return 0;
	}

	@Override
	public void generate(Random random, int chunkX, int chunkZ, World world, IChunkGenerator cg, IChunkProvider cp) {
		elements.forEach(element -> element.generateWorld(random, chunkX * 16, chunkZ * 16, world, world.provider.getDimension(), cg, cp));
	}

	@SubscribeEvent
	public void registerBlocks(RegistryEvent.Register<Block> event) {
		event.getRegistry().registerAll(blocks.stream().map(Supplier::get).toArray(Block[]::new));
	}

	@SubscribeEvent
	public void registerItems(RegistryEvent.Register<Item> event) {
		event.getRegistry().registerAll(items.stream().map(Supplier::get).toArray(Item[]::new));
	}

	@SubscribeEvent
	public void registerBiomes(RegistryEvent.Register<Biome> event) {
		event.getRegistry().registerAll(biomes.stream().map(Supplier::get).toArray(Biome[]::new));
	}

	@SubscribeEvent
	public void registerEntities(RegistryEvent.Register<EntityEntry> event) {
		event.getRegistry().registerAll(entities.stream().map(Supplier::get).toArray(EntityEntry[]::new));
	}

	@SubscribeEvent
	public void registerSounds(RegistryEvent.Register<net.minecraft.util.SoundEvent> event) {
	}

	@SubscribeEvent
	@SideOnly(Side.CLIENT)
	public void registerModels(ModelRegistryEvent event) {
		elements.forEach(element -> element.registerModels(event));
	}

	@EventHandler
	public void preInit(FMLPreInitializationEvent event) {
		MinecraftForge.EVENT_BUS.register(this);
		GameRegistry.registerFuelHandler(this);
		GameRegistry.registerWorldGenerator(this, 5);
		NetworkRegistry.INSTANCE.registerGuiHandler(this, new GuiHandler());
		elements.forEach(element -> element.preInit(event));
		proxy.preInit(event);
	}

	@EventHandler
	public void init(FMLInitializationEvent event) {
		elements.forEach(element -> element.init(event));
		proxy.init(event);
	}

	@EventHandler
	public void serverLoad(FMLServerStartingEvent event) {
		elements.forEach(element -> element.serverLoad(event));
	}

	public static class GuiHandler implements IGuiHandler {

		@Override
		public Object getServerGuiElement(int id, EntityPlayer player, World world, int x, int y, int z) {
			if (id == mcreator_delayAdjustGUI.GUIID)
				return new mcreator_delayAdjustGUI.GuiContainerMod(world, x, y, z, player);
			if (id == mcreator_filterGUI.GUIID)
				return new mcreator_filterGUI.GuiContainerMod(world, x, y, z, player);
			return null;
		}

		@Override
		public Object getClientGuiElement(int id, EntityPlayer player, World world, int x, int y, int z) {
			if (id == mcreator_delayAdjustGUI.GUIID)
				return new mcreator_delayAdjustGUI.GuiWindow(world, x, y, z, player);
			if (id == mcreator_filterGUI.GUIID)
				return new mcreator_filterGUI.GuiWindow(world, x, y, z, player);
			return null;
		}
	}

	public static class ModElement {

		public static advanced_redstone instance;

		public ModElement(advanced_redstone instance) {
			this.instance = instance;
		}

		public void init(FMLInitializationEvent event) {
		}

		public void preInit(FMLPreInitializationEvent event) {
		}

		public void generateWorld(Random random, int posX, int posZ, World world, int dimID, IChunkGenerator cg, IChunkProvider cp) {
		}

		public void serverLoad(FMLServerStartingEvent event) {
		}

		public void registerModels(ModelRegistryEvent event) {
		}

		public int addFuel(ItemStack fuel) {
			return 0;
		}
	}
}
